diff --git a/app/views/reports/_list.html.erb b/app/views/reports/_list.html.erb
index 29166bbf1..151609f81 100644
--- a/app/views/reports/_list.html.erb
+++ b/app/views/reports/_list.html.erb
@@ -14,8 +14,12 @@
   </tr>
   <% for report in @reports %>
     <tr>
-      <% unless params[:host_id] %>
-        <td><%= link_to h(report.host), host_reports_path(report.host) %></td>
+      <% if params[:host_id].nil? %>
+        <% if report.host.nil? %>
+            <td></td>
+        <% else %>
+            <td><%= link_to report.host, host_reports_path(report.host) %></td>
+        <% end %>
       <% end %>
       <td><%= reported_at_column(report) %></td>
       <td><%= report_event_column(report.applied, "label-info") %></td>
@@ -25,7 +29,8 @@
       <td><%= report_event_column(report.skipped, "label-info") %></td>
       <td><%= report_event_column(report.pending, "label-info") %></td>
       <td align="right">
-        <%= display_delete_if_authorized hash_for_report_path(:id => report.id), :confirm => _("Delete report for %s?") % report.host.name %>
+        <%= display_delete_if_authorized hash_for_report_path(:id => report.id).merge(:auth_object => report, :authorizer => authorizer),
+                                         :confirm => _("Delete report for %s?") % report.host.try(:name) %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/roles/_form.html.erb b/app/views/roles/_form.html.erb
index bf3eb1214..947232ead 100644
--- a/app/views/roles/_form.html.erb
+++ b/app/views/roles/_form.html.erb
@@ -1,39 +1,8 @@
-<% title_actions check_all_roles_links %>
-
 <%= form_for @role do |f| %>
   <%= base_errors_for @role %>
 
   <%= text_f f, :name, :class => @role.builtin? ? "disabled" : ""  %>
+  <%= hidden_field_tag :original_role_id, @original_role_id if @cloned_role %>
 
-  <div class='form-group'>
-    <label class='control-label'><%= _('Permissions') %></label>
-    <input placeholder="<%= _('Filter permissions') %>" class="search-query" onkeyup="filter_permissions(this);" type='text'>
-  </div>
-
-  <% perms_by_block = @role.setable_permissions.group_by {|p| p.security_block.to_s} %>
-  <div class='row'>
-  <% perms_by_block.keys.sort.in_groups(2,false) do |column| %>
-    <div class="col-md-4">
-      <% column.each do |block| %>
-        <div class="form-group">
-          <%= label_tag 'role[permissions]', image_tag("bullet_toggle_plus.png") + " " + block.humanize,:class=>"control-label", :data=>{:toggle=>'collapse', :target=>"##{block}"} %>
-          <div class="collapse" id="<%= block %>">
-            <ul class="inputs-list">
-              <% perms_by_block[block].each do |permission| %>
-                <li>
-                  <%= content_tag :div, 'role[permissions][]' do %>
-                    <%= check_box_tag 'role[permissions][]', permission.name, (@role.permissions.include? permission.name), :class => "role_checkbox" %>
-                    <%= permission.name %>
-                    <%= hidden_field_tag 'role[permissions][]' %>
-                  <% end %>
-                </li>
-              <% end %>
-            </ul>
-          </div>
-        </div>
-      <% end %>
-    </div>
-  <% end %>
-  </div>
   <%= submit_or_cancel f %>
 <% end %>
diff --git a/app/views/roles/index.html.erb b/app/views/roles/index.html.erb
index f5d121064..9210670ff 100644
--- a/app/views/roles/index.html.erb
+++ b/app/views/roles/index.html.erb
@@ -1,6 +1,5 @@
 <% title _("Roles") %>
-<% title_actions link_to(_("New role"), new_role_path),
-   link_to_if_authorized(_("Permissions report"), :action => 'report') %>
+<% title_actions link_to_if_authorized(_("New role"), hash_for_new_role_path) %>
 
 <table class="table table-bordered table-striped table-two-pane">
   <thead>
@@ -13,12 +12,14 @@
     <% for role in @roles %>
       <tr>
         <td>
-          <%= content_tag(role.builtin? ? 'em' : 'span', link_to_if_authorized(role.name, :action => 'edit', :id => role)) %>
+          <%= content_tag(role.builtin? ? 'em' : 'span', role.builtin? ? role.name : link_to_if_authorized(role.name, hash_for_edit_role_path(:id => role))) %>
         </td>
-        <td class="buttons">
-          <%= display_delete_if_authorized(hash_for_role_path(:id => role),
-                                    :confirm => (_("Delete %s?") % role.name)) unless role.builtin?
-          %>
+        <td>
+          <% links = [display_link_if_authorized(_('Filters and permissions'), hash_for_filters_path(:role_id => role)),
+                      display_link_if_authorized(_('Add permission'), hash_for_new_filter_path(:role_id => role)),
+                      display_link_if_authorized(_('Clone'), hash_for_clone_role_path(:id => role))] %>
+          <% links.push(display_delete_if_authorized(hash_for_role_path(:id => role), :confirm => (_("Delete %s?") % role.name))) unless role.builtin? %>
+          <%= action_buttons(*links) %>
         </td>
       </tr>
     <% end %>
diff --git a/app/views/smart_proxies/_form.html.erb b/app/views/smart_proxies/_form.html.erb
index 32a4bb0e6..24dafbd15 100644
--- a/app/views/smart_proxies/_form.html.erb
+++ b/app/views/smart_proxies/_form.html.erb
@@ -1,5 +1,5 @@
-<%= form_for @proxy do |f| %>
-  <%= base_errors_for @proxy %>
+<%= form_for @smart_proxy do |f| %>
+  <%= base_errors_for @smart_proxy %>
   <ul class="nav nav-tabs" data-tabs="tabs">
     <li class="active"><a href="#primary" data-toggle="tab"><%= _("Smart Proxy") %></a></li>
     <% if show_location_tab? %>
@@ -16,8 +16,8 @@
       <%= text_f(f, :url, :size => "col-md-8" ) %>
     </div>
 
-    <%= render 'taxonomies/loc_org_tabs', :f => f, :obj => @proxy %>
+    <%= render 'taxonomies/loc_org_tabs', :f => f, :obj => @smart_proxy %>
 
     <%= submit_or_cancel f %>
   </div>
-<% end %>
\ No newline at end of file
+<% end %>
diff --git a/app/views/smart_proxies/index.html.erb b/app/views/smart_proxies/index.html.erb
index 69fd8e2e6..9dfaf4fd5 100644
--- a/app/views/smart_proxies/index.html.erb
+++ b/app/views/smart_proxies/index.html.erb
@@ -10,29 +10,29 @@
     <th><%= _("Features") %></th>
     <th></th>
   </tr>
-  <% for proxy in @proxies %>
+  <% for proxy in @smart_proxies %>
     <tr>
-      <td><%= link_to_if_authorized proxy.name, hash_for_edit_smart_proxy_path(:id => proxy.id) %></td>
+      <td><%= link_to_if_authorized proxy.name, hash_for_edit_smart_proxy_path(:id => proxy.id).merge(:auth_object => proxy, :authorizer => authorizer) %></td>
       <td><%=h proxy.url %></td>
       <td><%=h proxy.features.to_sentence %></td>
       <td>
         <% ca = proxy.features.detect{|f| f.name == "Puppet CA"} %>
         <%= action_buttons(
           if ca
-            display_link_if_authorized(_("Certificates"), hash_for_smart_proxy_puppetca_index_path(:smart_proxy_id => proxy))
+            display_link_if_authorized(_("Certificates"), hash_for_smart_proxy_puppetca_index_path(:smart_proxy_id => proxy).merge(:auth_object => proxy, :permission => 'view_smart_proxies_puppetca', :authorizer => authorizer))
           end,
           if ca
-            display_link_if_authorized(_("Autosign"), hash_for_smart_proxy_autosign_index_path(:smart_proxy_id => proxy))
+            display_link_if_authorized(_("Autosign"), hash_for_smart_proxy_autosign_index_path(:smart_proxy_id => proxy).merge(:auth_object => proxy, :permission => 'view_smart_proxies_autosign', :authorizer => authorizer))
           end,
           if SETTINGS[:unattended] and proxy.features.detect{|f| f.name == "DHCP" }
             display_link_if_authorized(_("Import subnets"), hash_for_import_subnets_path(:smart_proxy_id => proxy))
           end,
-          display_link_if_authorized(_("Refresh features"), hash_for_refresh_smart_proxy_path(:id => proxy), :method => :put),
-          display_delete_if_authorized(hash_for_smart_proxy_path(:id => proxy), :confirm => _("Delete %s?") % proxy.name))%>
+          display_link_if_authorized(_("Refresh features"), hash_for_refresh_smart_proxy_path(:id => proxy).merge(:auth_object => proxy, :permission => 'edit_smart_proxies', :authorizer => authorizer), :method => :put),
+          display_delete_if_authorized(hash_for_smart_proxy_path(:id => proxy).merge(:auth_object => proxy, :authorizer => authorizer), :confirm => _("Delete %s?") % proxy.name))%>
       </td>
     </tr>
   <% end %>
 </table>
 
-<%= page_entries_info @proxies %>
-<%= will_paginate @proxies %>
+<%= page_entries_info @smart_proxies %>
+<%= will_paginate @smart_proxies %>
diff --git a/app/views/subnets/index.html.erb b/app/views/subnets/index.html.erb
index fe9fc37dd..d9a5d8d4e 100644
--- a/app/views/subnets/index.html.erb
+++ b/app/views/subnets/index.html.erb
@@ -13,13 +13,13 @@
   </tr>
   <% for subnet in @subnets %>
     <tr>
-      <td><%=link_to_if_authorized h(subnet.name), hash_for_edit_subnet_path(:id => subnet)%></td>
+      <td><%=link_to_if_authorized h(subnet.name), hash_for_edit_subnet_path(:id => subnet).merge(:auth_object => subnet, :authorizer => authorizer) %></td>
       <td><%=subnet.network_address %></td>
       <td><%=subnet.domains.to_sentence %></td>
       <td><%=subnet.vlanid %></td>
       <td><%=subnet.dhcp %></td>
       <td align="right">
-        <%= display_delete_if_authorized hash_for_subnet_path(:id => subnet), :confirm => _("Delete %s?") % subnet.name %>
+        <%= display_delete_if_authorized hash_for_subnet_path(:id => subnet).merge(:auth_object => subnet, :authorizer => authorizer), :confirm => _("Delete %s?") % subnet.name %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/usergroups/_form.html.erb b/app/views/usergroups/_form.html.erb
index 8d0779401..ac367600b 100644
--- a/app/views/usergroups/_form.html.erb
+++ b/app/views/usergroups/_form.html.erb
@@ -1,7 +1,24 @@
 <%= form_for @usergroup do |f| %>
   <%= base_errors_for @usergroup %>
-  <%= text_f f, :name %>
-  <%= multiple_checkboxes f, :usergroups, @usergroup, Usergroup, :label => _("User Groups") %>
-  <%= multiple_checkboxes f, :users, @usergroup, User, :label => _("Users") %>
+
+  <ul class="nav nav-tabs" data-tabs="tabs">
+    <li class="active"><a href="#primary" data-toggle="tab"><%= _("Usergroup") %></a></li>
+    <li><a href="#roles" data-toggle="tab"><%= _("Roles") %></a></li>
+  </ul>
+
+  <div class="tab-content">
+    <div class="tab-pane active" id="primary">
+
+      <%= text_f f, :name %>
+      <%= multiple_checkboxes f, :usergroups, @usergroup, Usergroup, :label => _("User Groups") %>
+      <%= multiple_checkboxes f, :users, @usergroup, User, :label => _("Users") %>
+    </div>
+
+    <div class="tab-pane" id="roles">
+      <%= checkbox_f f, :admin if User.current.can_change_admin_flag? %>
+      <%= multiple_checkboxes f, :roles, @usergroup, Role.givable.for_current_user, {:label => _('Roles')} %>
+    </div>
+  </div>
+
   <%= submit_or_cancel f %>
 <% end %>
diff --git a/app/views/usergroups/index.html.erb b/app/views/usergroups/index.html.erb
index fe1736554..6803fb986 100644
--- a/app/views/usergroups/index.html.erb
+++ b/app/views/usergroups/index.html.erb
@@ -11,11 +11,12 @@
   </tr>
   <% for usergroup in @usergroups %>
     <tr>
-      <td><%= link_to_if_authorized h(usergroup.name), hash_for_edit_usergroup_path(:id => usergroup.id) %></td>
+      <td><%= link_to_if_authorized h(usergroup.name), hash_for_edit_usergroup_path(:id => usergroup.id).merge(:auth_object => usergroup, :authorizer => authorizer) %></td>
       <td><%= h usergroup.users.map(&:login).to_sentence %></td>
       <td><%= h usergroup.usergroups.map(&:name).to_sentence %></td>
       <td>
-        <%= display_delete_if_authorized hash_for_usergroup_path(:id => usergroup), :confirm => (_("Delete %s?") % usergroup.name) %>
+        <%= display_delete_if_authorized hash_for_usergroup_path(:id => usergroup).merge(:auth_object => usergroup, :authorizer => authorizer),
+                                         :confirm => (_("Delete %s?") % usergroup.name) %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/users/_filters.html.erb b/app/views/users/_filters.html.erb
index 49cb78366..e289a0bfc 100644
--- a/app/views/users/_filters.html.erb
+++ b/app/views/users/_filters.html.erb
@@ -37,7 +37,7 @@
       <%= f.fields_for :user_facts do |builder| %>
         <%= render "user_fact", :f => builder %>
       <% end %>
-      <% if authorized_for(params[:controller], params[:action]) %>
+      <% if authorized_for(:controller => params[:controller], :action => params[:action]) %>
         <%= link_to_add_fields('+ ' + _("Add Filter"), f, :user_facts, "user_fact", :title => _("Add a fact filter")) %>
       <% end %>
     </div>
diff --git a/app/views/users/_form.html.erb b/app/views/users/_form.html.erb
index 717a525c3..237ce6440 100644
--- a/app/views/users/_form.html.erb
+++ b/app/views/users/_form.html.erb
@@ -5,7 +5,6 @@
     <li class="active"><a href="#primary" data-toggle="tab"><%= _("User") %></a></li>
     <% unless @editing_self %>
       <li><a href="#roles" data-toggle="tab"><%= _("Roles") %></a></li>
-      <li><a href="#filters" data-toggle="tab"><%= _("Filters") %></a></li>
       <% if show_location_tab? %>
         <li><a href="#locations" data-toggle="tab"><%= _("Locations") %></a></li>
       <% end %>
@@ -38,23 +37,14 @@
         <%= multiple_checkboxes f, :roles, @user, Role.givable.for_current_user, {:label => _('Roles')} %>
       </div>
 
-      <div class="tab-pane" id="filters">
-        <%= render("filters", :f => f) %>
-      </div>
       <% if show_location_tab? %>
         <div class="tab-pane" id="locations">
-          <div class="col-md-2">
-            <%= f.select :locations_andor, [[_("must be"), "and"], [_("plus all"), "or"]], {}, :class => "form-control" %>
-          </div>
           <%= location_selects f, @user.used_or_selected_location_ids, {:disabled => @user.used_location_ids, :label => ''} %>
         </div>
       <% end %>
 
       <% if show_organization_tab? %>
         <div class="tab-pane" id="organizations">
-          <div class="col-md-2">
-            <%= f.select :organizations_andor, [[_("must be"), "and"], [_("plus all"), "or"]], {}, :class => "form-control" %>
-          </div>
           <%= organization_selects f, @user.used_or_selected_organization_ids, {:disabled => @user.used_organization_ids, :label => ''} %>
         </div>
       <% end %>
diff --git a/app/views/users/_user_fact.html.erb b/app/views/users/_user_fact.html.erb
index 7d14b12a2..007b540cb 100644
--- a/app/views/users/_user_fact.html.erb
+++ b/app/views/users/_user_fact.html.erb
@@ -9,6 +9,6 @@
     <div class="col-sm-5">
       <%= f.text_field :criteria, :class=>"form-control" %>
     </div>
-    <%= authorized_for(params[:controller], params[:action]) ? link_to_remove_fields('', f, :class=>'btn') : '' %>
+    <%= authorized_for(:controller => params[:controller], :action => params[:action]) ? link_to_remove_fields('', f, :class=>'btn') : '' %>
   </div>
 </div>
diff --git a/app/views/users/index.html.erb b/app/views/users/index.html.erb
index 891e17993..0165bc1b4 100644
--- a/app/views/users/index.html.erb
+++ b/app/views/users/index.html.erb
@@ -15,14 +15,15 @@
   </tr>
   <% for user in @users %>
     <tr>
-      <td><%= gravatar_image_tag user.mail, :class => "gravatar" %> <%=link_to_if_authorized h(user.login), hash_for_edit_user_path(:id => user.id) %></td>
+      <td><%= gravatar_image_tag user.mail, :class => "gravatar" %> <%=link_to_if_authorized h(user.login), hash_for_edit_user_path(:id => user.id).merge(:auth_object => user, :authorizer => authorizer) %></td>
       <td><%=h user.firstname %></td>
       <td><%=h user.lastname %></td>
       <td><%=h user.mail %></td>
       <td><%=checked_icon user.admin? %></td>
       <td><%=h last_login_on_column(user)%></td>
       <td><%=h auth_source_column(user)%></td>
-      <td><%= display_delete_if_authorized hash_for_user_path(:id => user), :confirm => _("Delete %s?") % user.name %></td>
+      <td><%= display_delete_if_authorized hash_for_user_path(:id => user).merge(:auth_object => user, :authorizer => authorizer),
+                                           :confirm => _("Delete %s?") % user.name %></td>
     </tr>
   <% end %>
 </table>
diff --git a/bundler.d/test.rb b/bundler.d/test.rb
index 5839939ab..37daa6825 100644
--- a/bundler.d/test.rb
+++ b/bundler.d/test.rb
@@ -16,4 +16,5 @@ group :test do
   gem 'launchy'
   gem 'spork'
   gem 'factory_girl_rails', '~> 1.2', :require => false
+  gem 'oj'
 end
diff --git a/config/application.rb b/config/application.rb
index e2c2a7f78..54e0694bd 100644
--- a/config/application.rb
+++ b/config/application.rb
@@ -37,6 +37,7 @@ SETTINGS[:gce] = defined?(::Fog) && defined?(::Google::APIClient::VERSION)
 SETTINGS[:openstack] = SETTINGS[:rackspace] = SETTINGS[:ec2] = !! defined?(::Fog)
 
 require File.expand_path('../../lib/timed_cached_store.rb', __FILE__)
+require File.expand_path('../../lib/foreman/exception', __FILE__)
 require File.expand_path('../../lib/core_extensions', __FILE__)
 
 Bundler.require(:jsonp) if SETTINGS[:support_jsonp]
diff --git a/config/initializers/fix_cache.rb b/config/initializers/fix_cache.rb
new file mode 100644
index 000000000..5121ac252
--- /dev/null
+++ b/config/initializers/fix_cache.rb
@@ -0,0 +1,12 @@
+# if fix db cache flag is enabled and we are not running rake task, we want to
+# recreate cache
+
+if (Setting.table_exists? rescue(false))
+  flag = Setting::General.find_or_initialize_by_name('fix_db_cache',
+                                                     :description   => 'Fix DB cache on next Foreman restart',
+                                                     :settings_type => 'boolean', :default => false)
+end
+
+if File.basename($0) != "rake" && flag.value
+  CacheManager.recache!
+end
diff --git a/config/initializers/foreman.rb b/config/initializers/foreman.rb
index 8655af1ea..902170237 100644
--- a/config/initializers/foreman.rb
+++ b/config/initializers/foreman.rb
@@ -1,5 +1,4 @@
 require 'foreman/access_permissions'
-require 'foreman/default_data/loader'
 require 'menu/loader'
 require 'foreman/renderer'
 require 'foreman/controller'
@@ -18,9 +17,6 @@ if (Setting.table_exists? rescue(false))
   Setting.descendants.each(&:load_defaults)
 end
 
-# We load the default settings for the roles if they are not already present
-Foreman::DefaultData::Loader.load(false)
-
 #load topbar
 Menu::Loader.load
 
diff --git a/config/routes.rb b/config/routes.rb
index 1d9d84dae..e489511ec 100644
--- a/config/routes.rb
+++ b/config/routes.rb
@@ -171,6 +171,9 @@ Foreman::Application.routes.draw do
       resources :puppetca, :only => [:index, :update, :destroy]
       resources :autosign, :only => [:index, :new, :create, :destroy]
     end
+    collection do
+      get 'auto_complete_search'
+    end
   end
 
   resources :fact_values, :only => [:index] do
@@ -187,7 +190,11 @@ Foreman::Application.routes.draw do
   end
 
   if SETTINGS[:login]
-    resources :usergroups, :except => [:show]
+    resources :usergroups, :except => [:show] do
+      collection do
+        get 'auto_complete_search'
+      end
+    end
     resources :users, :except => [:show] do
       collection do
         get 'login'
@@ -200,13 +207,22 @@ Foreman::Application.routes.draw do
       end
     end
     resources :roles, :except => [:show] do
+      member do
+        get 'clone'
+      end
+      collection do
+        get 'auto_complete_search'
+      end
+    end
+
+    resources :filters, :except => [:show] do
       collection do
-        get 'report'
-        post 'report'
         get 'auto_complete_search'
       end
     end
 
+    resources :permissions, :only => [:index]
+
     resources :auth_source_ldaps, :except => [:show]
   end
 
diff --git a/config/routes/api/v2.rb b/config/routes/api/v2.rb
index e566839d8..bf454d43a 100644
--- a/config/routes/api/v2.rb
+++ b/config/routes/api/v2.rb
@@ -102,7 +102,18 @@ Foreman::Application.routes.draw do
         get :last, :on => :collection
       end
 
-      resources :roles, :except => [:new, :edit]
+      resources :roles, :except => [:new, :edit] do
+        resources :filters, :except => [:new, :edit] do
+          (resources :locations, :only => [:index, :show]) if SETTINGS[:locations_enabled]
+          (resources :organizations, :only => [:index, :show]) if SETTINGS[:organizations_enabled]
+        end
+      end
+      resources :permissions, :only => [:index, :show]
+
+      resources :filters, :except => [:new, :edit] do
+        (resources :locations, :only => [:index, :show]) if SETTINGS[:locations_enabled]
+        (resources :organizations, :only => [:index, :show]) if SETTINGS[:organizations_enabled]
+      end
 
       resources :settings, :only => [:index, :show, :update]
 
@@ -210,6 +221,7 @@ Foreman::Application.routes.draw do
           resources :compute_resources, :only => [:index, :show]
           resources :media, :only => [:index, :show]
           resources :smart_proxies, :only => [:index, :show]
+          resources :filters, :only => [:index, :show]
 
           resources :parameters, :except => [:new, :edit] do
             collection do
@@ -228,6 +240,7 @@ Foreman::Application.routes.draw do
             resources :compute_resources, :only => [:index, :show]
             resources :media, :only => [:index, :show]
             resources :smart_proxies, :only => [:index, :show]
+            resources :filters, :only => [:index, :show]
           end
 
         end
@@ -246,6 +259,7 @@ Foreman::Application.routes.draw do
           resources :compute_resources, :only => [:index, :show]
           resources :media, :only => [:index, :show]
           resources :smart_proxies, :only => [:index, :show]
+          resources :filters, :only => [:index, :show]
 
           resources :parameters, :except => [:new, :edit] do
             collection do
@@ -264,6 +278,7 @@ Foreman::Application.routes.draw do
             resources :compute_resources, :only => [:index, :show]
             resources :media, :only => [:index, :show]
             resources :smart_proxies, :only => [:index, :show]
+            resources :filters, :only => [:index, :show]
           end
 
         end
diff --git a/db/migrate/20131114084718_extend_user_role.rb b/db/migrate/20131114084718_extend_user_role.rb
new file mode 100644
index 000000000..a34261486
--- /dev/null
+++ b/db/migrate/20131114084718_extend_user_role.rb
@@ -0,0 +1,23 @@
+class ExtendUserRole < ActiveRecord::Migration
+  def up
+    remove_foreign_key 'user_roles', :name => 'user_roles_user_id_fk'
+    add_column :user_roles, :owner_type, :string, :default => 'User', :null => false
+    rename_column :user_roles, :user_id, :owner_id
+
+    add_index :user_roles, :owner_type
+    add_index :user_roles, :owner_id
+    add_index :user_roles, [:owner_id, :owner_type]
+
+    change_column :user_roles, :owner_id, :integer, :null => false
+  end
+
+  def down
+    remove_index :user_roles, [:owner_id, :owner_type]
+    remove_index :user_roles, :owner_id
+    remove_index :user_roles, :owner_type
+
+    rename_column :user_roles, :owner_id, :user_id
+    remove_column :user_roles, :owner_type
+    add_foreign_key 'user_roles', 'users', :name => 'user_roles_user_id_fk'
+  end
+end
diff --git a/db/migrate/20131114094841_create_cached_user_roles.rb b/db/migrate/20131114094841_create_cached_user_roles.rb
new file mode 100644
index 000000000..7ad8c6e45
--- /dev/null
+++ b/db/migrate/20131114094841_create_cached_user_roles.rb
@@ -0,0 +1,15 @@
+class CreateCachedUserRoles < ActiveRecord::Migration
+  def change
+    create_table :cached_user_roles do |t|
+      t.integer :user_id, :null => false
+      t.integer :role_id, :null => false
+      t.integer :user_role_id, :null => false
+
+      t.timestamps
+    end
+
+    add_index :cached_user_roles, :user_id
+    add_index :cached_user_roles, :role_id
+    add_index :cached_user_roles, :user_role_id
+  end
+end
diff --git a/db/migrate/20131122093940_calculate_cache_for_user_role.rb b/db/migrate/20131122093940_calculate_cache_for_user_role.rb
new file mode 100644
index 000000000..03d5aafc4
--- /dev/null
+++ b/db/migrate/20131122093940_calculate_cache_for_user_role.rb
@@ -0,0 +1,10 @@
+class CalculateCacheForUserRole < ActiveRecord::Migration
+  def up
+    UserRole.all.each do |user_role|
+      user_role.role && user_role.owner ? user_role.save! : user_role.delete
+    end
+  end
+
+  def down
+  end
+end
diff --git a/db/migrate/20131122170726_create_cached_usergroup_members.rb b/db/migrate/20131122170726_create_cached_usergroup_members.rb
new file mode 100644
index 000000000..46c710196
--- /dev/null
+++ b/db/migrate/20131122170726_create_cached_usergroup_members.rb
@@ -0,0 +1,15 @@
+class CreateCachedUsergroupMembers < ActiveRecord::Migration
+  def change
+    create_table :cached_usergroup_members do |t|
+      t.integer :user_id
+      t.integer :usergroup_id
+
+      t.timestamps
+    end
+
+    add_index :cached_usergroup_members, :user_id
+    add_index :cached_usergroup_members, :usergroup_id
+
+    UsergroupMember.all.each(&:save!)
+  end
+end
diff --git a/db/migrate/20131128150357_add_admin_flag_to_usergroup.rb b/db/migrate/20131128150357_add_admin_flag_to_usergroup.rb
new file mode 100644
index 000000000..7158238b6
--- /dev/null
+++ b/db/migrate/20131128150357_add_admin_flag_to_usergroup.rb
@@ -0,0 +1,5 @@
+class AddAdminFlagToUsergroup < ActiveRecord::Migration
+  def change
+    add_column :usergroups, :admin, :boolean, :null => false, :default => false
+  end
+end
diff --git a/db/migrate/20131202120621_create_permissions.rb b/db/migrate/20131202120621_create_permissions.rb
new file mode 100644
index 000000000..4c17336ef
--- /dev/null
+++ b/db/migrate/20131202120621_create_permissions.rb
@@ -0,0 +1,12 @@
+class CreatePermissions < ActiveRecord::Migration
+  def change
+    create_table :permissions do |t|
+      t.string :name, :null => false
+      t.string :resource_type
+
+      t.timestamps
+    end
+
+    add_index :permissions, [:name, :resource_type]
+  end
+end
diff --git a/db/migrate/20131202131847_create_filters.rb b/db/migrate/20131202131847_create_filters.rb
new file mode 100644
index 000000000..5cc4e1956
--- /dev/null
+++ b/db/migrate/20131202131847_create_filters.rb
@@ -0,0 +1,10 @@
+class CreateFilters < ActiveRecord::Migration
+  def change
+    create_table :filters do |t|
+      t.text :search
+      t.integer :role_id
+
+      t.timestamps
+    end
+  end
+end
diff --git a/db/migrate/20131202144415_create_filterings.rb b/db/migrate/20131202144415_create_filterings.rb
new file mode 100644
index 000000000..9bcd61e98
--- /dev/null
+++ b/db/migrate/20131202144415_create_filterings.rb
@@ -0,0 +1,13 @@
+class CreateFilterings < ActiveRecord::Migration
+  def change
+    create_table :filterings do |t|
+      t.integer :filter_id
+      t.integer :permission_id
+
+      t.timestamps
+    end
+
+    add_index :filterings, :filter_id
+    add_index :filterings, :permission_id
+  end
+end
diff --git a/db/migrate/20140110164135_add_foreign_keys_to_filters_and_filterings.rb b/db/migrate/20140110164135_add_foreign_keys_to_filters_and_filterings.rb
new file mode 100644
index 000000000..64151e1f4
--- /dev/null
+++ b/db/migrate/20140110164135_add_foreign_keys_to_filters_and_filterings.rb
@@ -0,0 +1,13 @@
+class AddForeignKeysToFiltersAndFilterings < ActiveRecord::Migration
+  def self.up
+    add_foreign_key "filters", "roles", :name => "filters_roles_id_fk"
+    add_foreign_key "filterings", "filters", :name => "filterings_filters_id_fk"
+    add_foreign_key "filterings", "permissions", :name => "filterings_permissions_id_fk"
+  end
+
+  def self.down
+    remove_foreign_key "filters", :name => "filters_roles_id_fk"
+    remove_foreign_key "filterings", :name => "filterings_filters_id_fk"
+    remove_foreign_key "filterings", :name => "filterings_permissions_id_fk"
+  end
+end
